--#############################################################################
-- 
-- FILENAME : adcTest.vhd
-- PURPOSE  : ads1284 interface controller
-- COMPILER : Quartus 8.0
-- VER      : 1.0
-- DATE     : 1/22/2009
-- 
-------------------------------------------------------------------------------
-- 
-- Description :
-- 
--
--
--
-- 
--
--*****************************************************************************
-- Version History
-- 
--  Date         Version   Who     Descriotion 
-- ------------ --------- ------- ---------------------------------------------
--  1/22/2009    1.0       Y.D.R   Created
-- 
--*****************************************************************************
-- 
--  COPYRIGHT : Ryu Deung Ryeol(pictor@kw.ac.kr)
--  
-- 
--#############################################################################
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;
use ieee.numeric_std.all;
use ieee.VITAL_Primitives.all;

entity adc_Test is
	port
	(			
		RESET 		        : in std_logic;                   -- system reset	
		CLK                 : in std_logic;           -- main clock 50Mhz
		
		-- Hard wired interface signal for ADS1284
		ADS1274_CLK         : out std_logic;
		ADS1274_SCLK        : out std_logic;
		ADS1274_FORMAT      : out std_logic_vector(2 downto 0); -- frame sync discrete logic defined only
		ADS1274_MODE        : out std_logic_vector(1 downto 0); -- high speed mode set ("00")
		ADS1274_POWDN       : out std_logic_vector(3 downto 0); -- high enable
		ADS1274_CLKDIV      : out std_logic;                    -- '1' 27Mhz
		ADS1274_DRDY_FSYNC  : out std_logic;                  -- SPI/FSYNC mode  
		ADS1274_SYNC        : out std_logic;                    --                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         : out std_logic;
		ADS1274_DATA        : in std_logic_vector(3 downto 0)  -- data input
		
	);
end adc_Test;

architecture rtl of adc_Test is

--	component PLL27M IS
--	PORT
--	(
--		areset		: IN STD_LOGIC  := '0';
--		inclk0		: IN STD_LOGIC  := '0';    -- 50Mhz
--		c0		    : OUT STD_LOGIC            -- 27Mhz
--	);
--	end component;
	
		-- OUTPUT FORMAT SEETING CONSTANT
    constant	FRAME_SYNC_DIS  : std_logic_vector(2 downto 0)	:=	"101";
    constant	SPI_DIS	        : std_logic_vector(2 downto 0)	:=	"010";
    
        -- Conversion mode SETTING CONSTANT
    constant	HIGH_SPEED	    : std_logic_vector(1 downto 0)	:=	"00";
    constant	HIGH_RESOLUTION	: std_logic_vector(1 downto 0)	:=	"01";
    
    
	signal adc_clk_pll : std_logic ;
begin

	ADS1274_CLK <= adc_clk_pll;
	ADS1274_SCLK <= adc_clk_pll;
	ADS1274_FORMAT <= FRAME_SYNC_DIS;
	ADS1274_MODE <= HIGH_SPEED;
	ADS1274_POWDN <= "1111";
	ADS1274_CLKDIV <= '1';
	ADS1274_SYNC <= '1';
	ADS1274_DRDY_FSYNC <= RESET;
	

	process(CLK)
	variable iclk : std_logic;
	begin
	
		if clk'event and clk = '1' then
			iclk := not iclk;
		end if;
		adc_clk_pll <= iclk;
	end process;
		
--	pll : PLL27M	port map
--	(
--		areset	=> '0',
--		inclk0	=> CLK,
--		c0		=> adc_clk_pll
--	);
--	

end rtl;
